GenAuth DocsDocuments
Concepts
User Guide
Development Integration
AgentAuth
Metadata
Development Integration
Multi-tenant (beta)
Console Documentation
Multi-tenant Console
Tenant Console
Saas Application Demo
Concepts
User Guide
Development Integration
AgentAuth
Metadata
Development Integration
Multi-tenant (beta)
Console Documentation
Multi-tenant Console
Tenant Console
Saas Application Demo
Old version
Development Integration
  • API

  • SDK

    • Java

      • Installation and use
      • User authentication module

      • Management module

        • Manage users

          • Get user list
          • Get user information
          • Get user information in batches
          • Create users
          • Create users in batches
          • Modify user information
          • Batch modify user information
          • Delete user
          • Get the user's external identity source
          • Get user role list
          • Get user real-name authentication information
          • Delete user real-name authentication information
          • Get user department list
          • Set user department
          • Get user group list
          • Get user MFA binding information
          • Get the archived user list
          • Force offline users
          • Judge whether the user exists
          • Get user-accessible applications
          • Get user-authorized applications
          • Determine whether the user has a certain role
          • Get the user's login history
          • Get the application that the user has logged in to
          • Get the identity source that the user has logged in to
          • User resignation
          • Batch user resignation
          • Get all resources authorized by the user
          • Check whether a user has a session login status in the application
          • Import user OTP
          • Set user MFA status
          • Get user MFA status
        • Management Roles

        • Manage user groups

        • Manage custom fields

        • Manage Resources and Permissions

        • Manage data resources and permissions

        • Manage Applications

        • Manage Identity Sources

        • Manage security configuration

        • Manage message service

        • Manage Pipeline

        • Manage Webhook

        • Get audit log

        • Manage metering and billing

        • Events
    • Node.js

    • Python

  • Error Codes
  1. Development Integration
  2. /
  3. SDK
  4. /
  5. Java
  6. /
  7. Management module

  8. /
  9. Manage users

  10. /
  11. Create users in batches

¶ Create users in batches

Update time: 2025-07-23 07:34:21
Edit

This document is automatically generated based on https://github.com/authing/authing-docs-factory and https://api-explorer.genauth.ai V3 API, and is consistent with API parameters and return results. If the document description is incorrect, please refer to V3 API.

To create users in batches, one of the email address, mobile phone number, and user name must be included. The email address, mobile phone number, user name, and externalId are unique in the user pool. This interface will create users as an administrator, so there is no need to perform security checks such as mobile phone number verification code verification.

¶ Method Name

ManagementClient.createUsersBatch

¶ Request Parameters

NameType
Is it required
Default Value
Description
Example Value
listCreateUserInfoDto[]Yes-User list array length limit: 50.[{"status":"Activated","email":"test@example.com","username":"bob","name":"Zhang San","nickname":"Zhang San","password":"passw0rd","photo":"https://files.authing.co/authing-console/default-user-avatar.png","gender":"M","birthdate":"2022-06-03","country":"CN","province":"BJ","city":"BJ","address":"Beijing Chaoyang","streetAddress":"xx Street, Chaoyang District, Beijing","postalCode":"438100","company":"steamory","browser":"Mozilla/5.0 (Linux; Android 10; V2001A; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/87.0.4280.141 Mobile Safari/537.36 VivoBrowser/10.2.10.0","device":"iOS","givenName":"San","familyName":"Zhang","middleName":"James","profile":"alice", "preferredUsername":"alice","website":"https://my-website.com","zoneinfo":"GMT-08:00","locale":"af","formatted":"132, My Street, Kingston, New York 12401.","region":"Xinjiang Uyghur Autonomous Region"}]

¶ Sample Code

package test.management;

import cn.authing.sdk.java.client.ManagementClient;
import cn.authing.sdk.java.dto.CreateUserBatchReqDto;
import cn.authing.sdk.java.dto.CreateUserInfoDto;
import cn.authing.sdk.java.dto.UserListRespDto;
import cn.authing.sdk.java.model.ManagementClientOptions;
import cn.authing.sdk.java.util.JsonUtils;

import java.util.ArrayList;
import java.util.Collections;

public class CreateUsersBatchTest {
    // Need to be replaced with your GenAuth Access Key ID
    private static final String ACCESS_KEY_ID = "AUTHING_ACCESS_KEY_ID";
    // Need to be replaced with your GenAuth Access Key Secret
    private static final String ACCESS_KEY_SECRET = "AUTHING_ACCESS_KEY_SECRET";

    public static void main(String[] args) throws Throwable {
        ManagementClientOptions clientOptions = new ManagementClientOptions();
        clientOptions.setAccessKeyId(ACCESS_KEY_ID);
        clientOptions.setAccessKeySecret(ACCESS_KEY_SECRET);
        // If you are a private deployment customer, you need to set the GenAuth service domain name
        // clientOptions.setHost("https://api.your-authing-service.com");

        ManagementClient client = new ManagementClient(clientOptions);

        CreateUserBatchReqDto reqDto = new CreateUserBatchReqDto();
        CreateUserInfoDto userInfoDto = new CreateUserInfoDto();
        userInfoDto.setUsername("test");
        reqDto.setList(Collections.singletonList(userInfoDto));
        UserListRespDto response = client.createUsersBatch(reqDto);
        System.out.println(JsonUtils.serialize(response));
    }
}

¶ Request Response

Type: UserListRespDto

NameTypeDescription
statusCodenumberBusiness status code, which can be used to determine whether the operation is successful. 200 means success.
messagestringDescription
apiCodenumberSegmented error code, which can be used to get the specific error type (successful requests are not returned). For a detailed list of error codes, see: API Code List (opens new window)
requestIdstringRequest ID. Returned when the request fails.
dataarrayuser list

Example Results:

{
  "statusCode": 200,
  "message": "Operation successful",
  "requestId": "934108e5-9fbf-4d24-8da1-c330328abd6c",
  "data": {
    "userId": "6229ffaxxxxxxxxcade3e3d9",
    "createdAt": "2022-07-03T03:20:30.000Z",
    "updatedAt": "2022-07-03T03:20:30.000Z",
    "status": "Activated",
    "workStatus": "Active",
    "externalId": "10010",
    "email": "test@example.com",
    "phone": "188xxxx8888",
    "phoneCountryCode": "+86",
    "username": "bob",
    "name": "Zhang San",
    "nickname": "Zhang San",
    "photo": "https://files.authing.co/authing-console/default-user-avatar.png",
    "loginsCount": 3,
    "lastLogin": "2022-07-03T03:20:30.000Z",
    "lastIp": "127.0.0.1",
    "gender": "M",
    "emailVerified": true,
    "phoneVerified": true,
    "passwordLastSetAt": "2022-07-03T03:20:30.000Z",
    "birthdate": "2022-06-03",
    "country": "CN",
    "province": "BJ",
    "city": "BJ",
    "address": "Beijing Chaoyang",
    "streetAddress": "xx Street, Chaoyang District, Beijing",
    "postalCode": "438100",
    "company": "steamory",
    "browser": "Mozilla/5.0 (Linux; Android 10; V2001A; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/87.0.4280.141 Mobile Safari/537.36 VivoBrowser/10.2.10.0",
    "device": "iOS",
    "givenName": "San",
    "familyName": "Zhang",
    "middleName": "James",
    "profile": "alice",
    "preferredUsername": "alice",
    "website": "https://my-website.com",
    "zoneinfo": "GMT-08:00",
    "locale": "af",
    "formatted": "132, My Street, Kingston, New York 12401.",
    "region": "Xinjiang Uyghur Autonomous Region",
    "userSourceType": "register",
    "passwordSecurityLevel": 1,
    "departmentIds": "[\"624d930c3xxxx5c08dd4986e\",\"624d93102xxxx012f33cd2fe\"]",
    "identities": {
      "identityId": "62299d8b866d2dab79a89dc4",
      "extIdpId": "6076bacxxxxxxxxd80d993b5",
      "provider": "wechat",
      "type": "openid",
      "userIdInIdp": "oj7Nq05R-RRaqak0_YlMLnnIwsvg",
      "accessToken": "57_fK0xgSL_NwVlS-gmUwlMQ2N6AONNIOAYxxxx",
      "refreshToken": "57_IZFu91Ak1Wg6DRytZFFIOd3upNF5lH7vPxxxxx",
      "originConnIds": "[\"605492ac41xxxxe0362f0707\"]"
    },
    "identityNumber": "420421xxxxxxxx1234",
    "customData": {
      "school": "Beijing University",
      "age": 22
    },
    "statusChangedAt": "2022-07-03T03:20:30.000Z"
  }
}

¶ Data Structure

¶ CreateUserInfoDto

NameType
Is it required
Description
Example Value
statusstringNoCurrent account statusSuspended
emailstringNoEmail address, case insensitivetest@example.com
phonestringNoPhone number without area code. If Yes, it is a foreign phone number. Please specify the area code in the phoneCountryCode parameter.188xxxx8888
phoneCountryCodestringNoPhone area code. This parameter is optional for phone numbers in mainland China. The GenAuth SMS service does not currently support international phone numbers. You need to configure the corresponding international SMS service in the GenAuth console. For a complete list of phone area codes, please refer to https://en.wikipedia.org/wiki/List_of_country_calling_codes.+86
usernamestringNoUsername, unique in the user poolbob
externalIdstringNoThird-party external ID10010
namestringNoUser's real name, not uniqueZhang San
nicknamestringNoNicknameZhang San
photostringNoAvatar linkhttps://files.authing.co/authing-console/default-user-avatar.png
genderstringNoGenderM
emailVerifiedbooleanNoEmail Yes No Verificationtrue
phoneVerifiedbooleanNoPhone number Yes No Verificationtrue
birthdatestringNoDate of birth2022-06-03
countrystringNoCountryCN
provincestringNoProvinceBJ
citystringNoCityBJ
addressstringNoAddressBeijing Chaoyang
streetAddressstringNoStreet addressBeijing Chaoyang District xxx Street
postalCodestringNoPostal code438100
companystringNoCompanysteamory
browserstringNoLast login browser UAMozilla/5.0 (Linux; Android 10; V2001A; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/87.0.4280.141 Mobile Safari/537.36 VivoBrowser/10.2.10.0
devicestringNoLast login deviceiOS
givenNamestringNoFirst namexxx
familyNamestringNoLast nameZhang
middleNamestringNoMiddle NameJames
profilestringNoPreferred Usernamealice
preferredUsernamestringNoPreferred Usernamealice
websitestringNoUser personal websitehttps://my-website.com
zoneinfostringNoUser time zone informationGMT-08:00
localestringNoLocaleaf
formattedstringNoStandard full address132, My Street, Kingston, New York 12401.
regionstringNoUser locationXinjiang Uyghur Autonomous Region
passwordstringNoUser password, in plain text by default. We use the HTTPS protocol to securely transmit passwords, which can ensure security to a certain extent. If you need a higher level of security, we also support RSA256 and SM2 encryption for passwords. See the passwordEncryptType parameter for details.passw0rd
saltstringNoSalt for encrypting user passwordsdgisaeieruur
tenantIdsarrayNoTenant IDs["63f867961cxxxx41e7ccb582","63bea7828f4xxxxbfa80df93"]
otpNoOTP authenticator for the user Nested Type: CreateUserOtpDto.{"recoveryCode":"b471-8ec0-874a-087f-bccb-cd54","secret":"HZ2F6J3AGNAVSOTV"}
departmentIdsarrayNoList of department IDs to which the user belongs["624d930c3xxxx5c08dd4986e","624d93102xxxx012f33cd2fe"]
customDataobjectNoCustom data. The key in the passed object must first be defined in the user pool for the relevant custom fields{"school":"Beijing University","age":22}
metadataSourceobjectNoData object data. The key in the passed object must first be defined in the user pool for the relevant custom fields{"school":"Beijing University","age":22}
identitiesarrayNoThird-party identity source (it is recommended to call the binding interface for binding) Nested Type: CreateIdentityDto.[{"extIdpId":"6076bacxxxxxxxxd80d993b5","provider":"wechat","type":"openid","userIdInIdp":"oj7Nq05R-RRaqak0_YlMLnnIwsvg"}]
identityNumberstringNoUser ID number420421xxxxxxxx1234

¶ CreateUserOtpDto

NameType
Is it required
Description
Example Value
secretstringYesOTP SecretHZ2F6J3AGNAVSOTV
recoveryCodestringNoOTP Recovery Codeb471-8ec0-874a-087f-bccb-cd54

¶ CreateIdentityDto

NameType
Is it required
Description
Example Value
extIdpIdstringYesIdentity source connection ID6076bacxxxxxxxxd80d993b5
providerstringYesExternal identity source Type:
- wechat: WeChat
- qq: QQ
- wechatwork: WeChat for Business
- dingtalk: DingTalk
- weibo: Weibo
- github: GitHub
- alipay: Alipay
- baidu: Baidu
- lark: Feishu
- welink: Welink
- yidun: NetEase Yidun
- qingcloud: Qingyun
- google: Google
- gitlab: GitLab
- gitee: Gitee
- twitter: Twitter
- facebook: Facebook
- slack: Slack
- linkedin: Linkedin
- instagram: Instagram
- oidc: OIDC-based enterprise identity source
- oauth2: OAuth2-based enterprise identity source
- saml: SAML-based enterprise identity source
- ldap: LDAP-based enterprise identity source
- ad: AD-based enterprise identity source
- cas: CAS-based enterprise identity source
- azure-ad: Azure AD-based enterprise identity source
oidc
typestringYesIdentity type, such as unionid, openid, primaryopenid
userIdInIdpstringYesID in the external identity sourceoj7Nq05R-RRaqak0_YlMLnnIwsvg
userInfoInIdpobjectYesUser's identity information in idp
accessTokenstringNoAccess Token in the external identity source (this parameter is only returned when the user actively obtains it, and it will not be returned by the management interface).57_fK0xgSL_NwVlS-gmUwlMQ2N6AONNIOAYxxxx
refreshTokenstringNoRefresh Token in the external identity source (this parameter is only returned when the user actively obtains it, and it will not be returned by the management interface).57_IZFu91Ak1Wg6DRytZFFIOd3upNF5lH7vPxxxxx
originConnIdsarrayYesIdentity source connection ID list from which the identity comes["605492ac41xxxxe0362f0707"]

¶ CreateUserOptionsDto

NameType
Is it required
Description
Example Value
keepPasswordbooleanNoThis parameter is usually set when migrating old user data to GenAuth. When this switch is turned on, the password field will be written directly to the GenAuth database, and GenAuth will not encrypt this field again. If your password is not stored in plain text, you should keep it turned on and write a password function to calculate it.
autoGeneratePasswordbooleanNoYes No Automatically generate passwords
resetPasswordOnFirstLoginbooleanNoYes No Force users to reset their passwords on the first login
departmentIdTypestringNoThe type of the parent department ID used in this calldepartment_id
sendNotificationNoOptions for sending email and mobile phone number when resetting passwords Nested Type: SendCreateAccountNotificationDto.{"sendEmailNotification":true,"sendPhoneNotification":true}
passwordEncryptTypestringNoPassword encryption type, supports RSA256 and SM2 algorithms. The default is none, no encryption.
- none: Do not encrypt the password, use plain text for transmission.
- rsa: Use RSA256 algorithm to encrypt the password, and need to use the RSA public key of GenAuth service for encryption. Please read the Introduction section to learn how to obtain the RSA256 public key of GenAuth service.
- sm2: Use SM2 algorithm (opens new window) to encrypt the password, and need to use the SM2 public key of GenAuth service for encryption. Please read the Introduction section to learn how to obtain the SM2 public key of GenAuth service.
sm2

¶ SendCreateAccountNotificationDto

NameType
Is it required
Description
Example Value
sendEmailNotificationbooleanNoAfter creating an account, Yes No send email notification
sendPhoneNotificationbooleanNoAfter creating an account, Yes No send SMS notification
appIdstringNoWhen sending the login address, the specified application id will send the login address of this application to the user's email or mobile phone number. The default is the login address of the user pool application panel.appid1

¶ UserDto

NameType
Is it required
Description
Example Value
userIdstringYesThe unique identifier of the user, which can be user ID, user name, email, phone number, externalId, or ID in an external identity source. For details, see the description of the userIdType field. The default is user id.6229ffaxxxxxxxxcade3e3d9
createdAtstringyescreation time2022-07-03T03:20:30.000Z
updatedAtstringyesupdate time2022-07-03T03:20:30.000Z
statusstringyescurrent status of the account:
- Activated: normal status
- Suspended: deactivated
- Deactivated: disabled
- Resigned: resigned
- Archived: archived
Suspended
workStatusstringyescurrent work status of the accountClosed
externalIdstringnothird-party external ID10010
emailstringnoemail address, case insensitivetest@example.com
phonestringNoPhone number without area code. If it is a foreign phone number, specify the area code in the phoneCountryCode parameter.188xxxx8888
phoneCountryCodestringNoMobile phone area code. This field is optional for mainland China mobile phone numbers. The GenAuth SMS service does not yet support international mobile phone numbers. You need to configure the corresponding international SMS service in the GenAuth console. For a complete list of mobile phone area codes, please refer to https://en.wikipedia.org/wiki/List_of_country_calling_codes.+86
usernamestringNoUsername, unique in the user poolbob
namestringNoUser's real name, not uniqueZhang San
nicknamestringNoNicknameZhang San
photostringNoAvatar linkhttps://files.authing.co/authing-console/default-user-avatar.png
loginsCountnumberNoTotal number of historical logins3
lastLoginstringNoLast login time2022-07-03T03:20:30.000Z
lastIpstringNoLast login IP127.0.0.1
genderstringYesGender:
- M: Male, male
- F: Female, female
- U: unknown, unknown
M
emailVerifiedbooleanyesEmail verifiedtrue
phoneVerifiedbooleanyesPhone number verifiedtrue
passwordLastSetAtstringnoUser's last password change time2022-07-03T03:20:30.000Z
birthdatestringNoDate of birth2022-06-03
countrystringNoCountryCN
provincestringNoProvinceBJ
citystringNoCityBJ
addressstringNoAddressBeijing Chaoyang
streetAddressstringNoStreet addressBeijing Chaoyang District xxx Street
postalCodestringNoPostal code438100
companystringNoCompanysteamory
browserstringNoLast browser used for login UAMozilla/5.0 (Linux; Android 10; V2001A; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/87.0.4280.141 Mobile Safari/537.36 VivoBrowser/10.2.10.0
devicestringNoThe device used when logging in last timeiOS
givenNamestringnofirst namexxx
familyNamestringnolast namexxx
middleNamestringnomiddle nameJames
profilestringnoPreferred Usernamealice
preferredUsernamestringnoPreferred Usernamealice
websitestringnoUser personal websitehttps://my-website.com
zoneinfostringnoUser time zone informationGMT-08:00
localestringnoLocaleaf
formattedstringnoFull standard address132, My Street, Kingston, New York 12401.
regionstringnoUser locationXinjiang Uyghur Autonomous Region
userSourceTypestringyesSource type:
- excel: via excel Import
- register: User self-registration
- adminCreated: Manual creation by the administrator (including creating users using the management API)
- syncTask: Sync task in the sync center
excel
userSourceIdstringNoApplication ID or sync task ID
lastLoginAppstringNoID of the application that the user last logged in to
mainDepartmentIdstringNoID of the user's main department
lastMfaTimestringNoTime when the user last performed MFA authentication
passwordSecurityLevelnumberNoUser password security strength level1
resetPasswordOnNextLoginbooleanNoRequire password reset on next login
registerSourcearrayNoRegistration method
departmentIdsarrayNoList of department IDs to which the user belongs["624d930c3xxxx5c08dd4986e","624d93102xxxx012f33cd2fe"]
identitiesarrayNoExternal identity source nested Type: IdentityDto.
identityNumberstringNoUser ID number420421xxxxxxxx1234
customDataobjectNoUser's extended field data{"school":"Beijing University","age":22}
postIdListarrayNoUser-associated department ID
statusChangedAtstringNoUser status last modified time2022-07-03T03:20:30.000Z
tenantIdstringNoUser tenant ID

¶ IdentityDto

NameType
Is it required
Description
Example Value
identityIdstringYesIdentity source ID62299d8b866d2dab79a89dc4
extIdpIdstringYesIdentity source connection ID6076bacxxxxxxxxd80d993b5
providerstringYesExternal identity source Type:
- wechat: WeChat
- qq: QQ
- wechatwork: WeChat for Business
- dingtalk: DingTalk
- weibo: Weibo
- github: GitHub
- alipay: Alipay
- baidu: Baidu
- lark: Feishu
- welink: Welink
- yidun: NetEase Yidun
- qingcloud: Qingyun
- google: Google
- gitlab: GitLab
- gitee: Gitee
- twitter: Twitter
- facebook: Facebook
- slack: Slack
- linkedin: Linkedin
- instagram: Instagram
- oidc: OIDC-type enterprise identity source
- oauth2: OAuth2-type enterprise identity source
- saml: SAML-type enterprise identity source
- ldap: LDAP-type enterprise identity source
- ad: AD-type enterprise identity source
- cas: CAS-type enterprise identity source
- azure-ad: Azure AD-type enterprise identity source
oidc
typestringYesIdentity type, such as unionid, openid, primaryopenid
userIdInIdpstringYesID in the external identity sourceoj7Nq05R-RRaqak0_YlMLnnIwsvg
userInfoInIdpobjectYesUser identity information in idp
accessTokenstringNoAccess Token in the external identity source (this parameter is only returned when the user actively obtains it, and the management side interface will not return it).57_fK0xgSL_NwVlS-gmUwlMQ2N6AONNIOAYxxxx
refreshTokenstringNoRefresh Token in the external identity source (this parameter is only returned when the user actively obtains it, and the management side interface will not return it).57_IZFu91Ak1Wg6DRytZFFIOd3upNF5lH7vPxxxxx
originConnIdsarrayYesList of identity origin connection IDs that the identities came from["605492ac41xxxxe0362f0707"]
Previous article: Create users Next article: Modify user information
  • Method Name
  • Request Parameters
  • Sample Code
  • Request Response
  • Data Structure

User identity management

Integrated third-party login
Customized authentication process

Enterprise internal management

Single sign-on
Multi-factor authentication
Permission management

Developer

Development Documentation
GitHub (opens new window)

Company

official@genauth.ai
16th Floor, Building B, Beichen Century Center, Chaoyang District, Beijing (Total)
Room 406, 4th Floor, Block B, No. 200, Tianfu Fifth Street, High-tech Zone, Chengdu (Branch)

© Beijing Steamory Technology Co., Ltd.